{------------------------------------------------------------------------------}
{ TWAIN Sample Source                                                          }
{ Copyright (C) '91-'93 TWAIN Working Group:                                   }
{ Aldus, Caere, Eastman-Kodak, Logitech,                                       }
{ Hewlett-Packard Corporations.                                                }
{ All rights reserved.                                                         }
{                                                                              }
{ This source code was converted from C to Turbo Pascal for Windoes by         }
{                                                                              }
{   MCM Design                                                                 }
{   Marc Christopher Martin                                                    }
{   Australiensvej 34                                                          }
{   2100 Copenhagen OE                                                         }
{   Denmark                                                                    }
{                                                                              }
{   e-mail support@mcm-design.dk                                               }
{                                                                              }
{------------------------------------------------------------------------------}

Unit twd_type;

{------------------------------------------------------------------------------}
{$A+} { Align data Byte = $A-, Word = $A+.                                     }
{$F+} { Force FAR call.                                                        }
{$N-} { CoProcessor code generation.                                           }
{$R-} { Range check.                                                           }
{$W-} { Protected mode only $W-, Real mode stack frame support $W+.            }
{$X+} { Extended syntax (When on, function can be used as procedures).         }
{------------------------------------------------------------------------------}

interface

uses WinTypes, twain;

{------------------------------------------------------------------------------}
{ This header contains the function prototypes and constants required for the  }
{ TWD... source routines used to generate the toolkit sample Source.           }
{------------------------------------------------------------------------------}

{------------------------------------------------------------------------------}
{ Constants                                                                    }
{------------------------------------------------------------------------------}

{------------------------------------------------------------------------------}
{ Source Version                                                               }
{------------------------------------------------------------------------------}
const MAX_TWPATH           = 260;
      VERSION_MAJOR        =   0;
      VERSION_MINOR        =   1;

{ Source State defines                                                         }
      STATE1               = 100;
      STATE2               = 200;
      STATE3               = 300;
      STATE4               = 400;
      STATE5               = 500;
      STATE6               = 600;
      STATE7               = 700;

      E_IDENTITYMSG        = 'General failure in response to DAT_IDENTITY.  ';
      E_INTERFACEMSG       = 'General failure in response to DAT_USERINTERFACE.  ';

      E_CONTROLMSG         = 'General failure in response to DAT_NULL.  ';
      E_ENABLEDS           = 'General failure in response to MSG_ENABLEDS.  ';
      E_DISABLEDS          = 'General failure in response to MSG_DISABLEDS.  ';
      E_OPENDS             = 'General failure in response to MSG_OPENDS.  ';
      E_CLOSEDS            = 'General failure in response to MSG_CLOSEDS.  ';
      
      E_CAPABILITYMSG      = 'General failure in response to DAT_CAPS.  ';
      E_STATUSMSG          = 'General failure in response to DAT_STATUS.  ';
      E_PENDINGXFERMSG     = 'General failure in response to DAT_PENDINGXFER.  ';

      E_SETUPXFERMECHMSG   = 'General failure in response to DAT_XFERMECH.  ';
      E_SETUPXFERMECHSET   = 'General failure in response to DAT_XFERMECH, MSG_SET, non-supported type.  ';

      E_SETUPMEMXFER       = 'General failure in response to DAT_SETUPMEMXFER, not supported.  ';
      E_SETUPFILEXFER      = 'General failure in response to DAT_SETUPFILEXFER, not supported.  ';

      E_XFERGROUP          = 'General failure in response to DAT_XFERGROUP, not supported.  ';

      E_SETUPNATIVEXFERSET = 'General failure in response to DAT_SETUPNATIVEXFER, non-supported type.  ';
      E_SETUPNATIVEXFERMSG = 'General failure in response to DAT_SETUPNATIVEXFER.  ';

      E_PALETTE8           = 'General failure in response to DAT_PALETTE8.  ';

      E_IMAGEINFOFOPEN     = 'General failure in transfer file open.  ';
      E_IMAGEINFORHEAD     = 'General failure in transfer reading file header.  ';
      E_IMAGEINFOFTYPE     = 'General failure in transfer file is wrong type.  ';
      E_IMAGEINFOIHEAD     = 'General failure in transfer reading file info header.  ';
      E_IMAGEINFOBTYPE     = 'General failure in transfer bad info header info.  ';
      E_IMAGEINFOMSG       = 'General failure in transfer.  ';

      E_IMAGELAYOUTMSG     = 'General failure in response to DAT_IMAGEINFO.  ';
      E_IMAGEMEMXFERWTYPE  = 'General failure in response to DAT_IMAGEMEMXFER, wrong setup type.  ';
      E_IMAGEMEMXFERMSG    = 'General failure in response to DAT_IMAGEMEMXFER.  ';
      E_IMAGENATIVEXFERMSG = 'General failure in response to DAT_IMAGENATIVEXFER.  ';

      E_CONTAINER          = 'General failure creating a container.  ';


{------------------------------------------------------------------------------}
{ This struct is used to dispatch to functions to handle the                   }
{ various structures that need to be filled in.  It could be                   }
{ extended to check the Message field as well.                                 }
{------------------------------------------------------------------------------}

type TMsgMapper = record
                  ID    : TW_UINT16;   { Either the struct id or msg id        }
                  pFunc : TFarProc;    { Pointer to fnt which processes msg    }
                  end;

     pMsgMapper = ^TMsgMapper;

     TMsgMap    = array[0..0] of TMsgMapper;
     PMsgMap    = ^TMsgMap;


{ Internal structure to store TW messages.                                     }
type  TTWMessage = record { MCM 230996, TWMsg was renamed to TTWMessage.       }
                   pSrc  : pTW_IDENTITY;
                   DG    : TW_UINT32;
                   DAT   : TW_UINT16;
                   MSG   : TW_UINT16;
                   pData : TW_MEMREF;
                   end;

      PTWMessage = ^TTWMessage;

      TMsgFunction   = function(PTWMsg  : PTWMessage) : TW_UINT16;

var   MsgFunction     : TMsgFunction;



{------------------------------------------------------------------------------}
{ MCM, Moved from twd_main                                                     }
{------------------------------------------------------------------------------}
var   DSState         : integer;     { Global state machine place holder.      }
      dsIdentity      : TW_IDENTITY; { Who we are.                             }
      appIdentity     : TW_IDENTITY; { To keep track of who's driving us.      }
      hImageDlg       : THandle;
      TWAINFileName   : array[0..MAX_TWPATH-1] of char;
      hDSInst         : Thandle;     { Keep track of who we are.               }
      hDibPal         : HPalette;    { Color palette handle.                   }
      Aof             : TOFSTRUCT;

{------------------------------------------------------------------------------}
{ MCM, Moved from twd_prot, ImageMemXferMsg.                                   }
{------------------------------------------------------------------------------}
      XferFirst       : bool;
      XferDone        : boolean;
      XferCount       : longint;
      BytesOut        : longint;

implementation

end. { End Unit twd_type.                                                      }
